﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Threading;

namespace yaap
{
    public partial class Form1 : Form
    {
        [DllImport("user32.dll")]
        extern static int SendInput(int nInputs, ref INPUT pInputs, int cbSize);
        [DllImport("user32.dll")]
        extern static IntPtr GetMessageExtraInfo();
        [DllImport("user32.dll")]
        extern static int SetForegroundWindow(IntPtr hwnd);
        [DllImport("user32.dll")]
        extern static int GetWindowRect(IntPtr hwnd, out RECT rect);
        [DllImport("user32.dll")]
        extern static int GetClientRect(IntPtr hwnd, out RECT rect);
        [DllImport("user32.dll")]
        extern static uint MapVirtualKey(uint uCode, uint uMapType);
        [DllImport("user32.dll")]
        extern static int RegisterHotKey(IntPtr hWnd, int id, int modKey, int key);
        [DllImport("user32.dll")]
        extern static int UnregisterHotKey(IntPtr hWnd, int id);
        [DllImport("user32.dll")]
        static extern IntPtr GetDC(IntPtr hwnd);
        [DllImport("user32.dll")]
        static extern Int32 ReleaseDC(IntPtr hwnd, IntPtr hdc);
        [DllImport("gdi32.dll")]
        static extern uint GetPixel(IntPtr hdc, int nXPos, int nYPos);

        [StructLayout(LayoutKind.Explicit)]
        private struct INPUT
        {
            [FieldOffset(0)]
            public uint type;
            [FieldOffset(4)]
            public MOUSEINPUT mi;
            [FieldOffset(4)]
            public KEYBDINPUT ki;
            [FieldOffset(4)]
            public HARDWAREINPUT hi;
        }
        [StructLayout(LayoutKind.Sequential)]
        private struct MOUSEINPUT
        {
            public int dx;
            public int dy;
            public uint mouseData;
            public uint dwFlags;
            public uint time;
            public IntPtr dwExtraInfo;
        }
        [StructLayout(LayoutKind.Sequential)]
        private struct KEYBDINPUT
        {
            public ushort wVk;
            public ushort wScan;
            public uint dwFlags;
            public uint time;
            public IntPtr dwExtraInfo;
        }
        [StructLayout(LayoutKind.Sequential)]
        private struct HARDWAREINPUT
        {
            public uint uMsg;
            public ushort wParamL;
            public ushort wParamH;
        }
        [StructLayout(LayoutKind.Sequential)]
        struct RECT
        {
            public int left;
            public int top;
            public int right;
            public int bottom;
        }

        const int MOD_ALT = 0x0001;
        const int MOD_CONTROL = 0x0002;
        const int MOD_SHIFT = 0x0004;
        const int WM_HOTKEY = 0x0312;
        const int HOTKEY_ID = 0x0002;

        const ushort VK_SPACE = 0x20;
        const ushort VK_LEFT = 0x25;
        const ushort VK_UP = 0x26;
        const ushort VK_RIGHT = 0x27;
        const ushort VK_DOWN = 0x28;

        private string shot = "None";
        private ushort spin = 0;
        private decimal power = 50;
        private IntPtr pangyahwnd;
        private RECT pangyarect;
        private int panoffset = -4;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            spin = 0;
            button1.ForeColor = Color.Red;
            button2.ForeColor = Color.Black;
            button3.ForeColor = Color.Black;
            button4.ForeColor = Color.Black;
            button5.ForeColor = Color.Black;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            spin = VK_UP;
            button1.ForeColor = Color.Black;
            button2.ForeColor = Color.Red;
            button3.ForeColor = Color.Black;
            button4.ForeColor = Color.Black;
            button5.ForeColor = Color.Black;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            spin = VK_LEFT;
            button1.ForeColor = Color.Black;
            button2.ForeColor = Color.Black;
            button3.ForeColor = Color.Red;
            button4.ForeColor = Color.Black;
            button5.ForeColor = Color.Black;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            spin = VK_RIGHT;
            button1.ForeColor = Color.Black;
            button2.ForeColor = Color.Black;
            button3.ForeColor = Color.Black;
            button4.ForeColor = Color.Red;
            button5.ForeColor = Color.Black;
        }

        private void button5_Click(object sender, EventArgs e)
        {
            spin = VK_DOWN;
            button1.ForeColor = Color.Black;
            button2.ForeColor = Color.Black;
            button3.ForeColor = Color.Black;
            button4.ForeColor = Color.Black;
            button5.ForeColor = Color.Red;
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            power = numericUpDown1.Value;
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (GetPangyaClient())
            {
                SetForegroundWindow(pangyahwnd);
                Thread.Sleep(1000);
                AutoPangya();
             }
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1.Checked)
            {
                shot = "None";
            }
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton2.Checked)
            {
                shot = "Toma";
            }
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton3.Checked)
            {
                shot = "Cobra";
            }
        }

        private void radioButton4_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton4.Checked)
            {
                shot = "Spike";
            }
        }

        private bool GetPangyaClient()
        {
            Process[] procs = Process.GetProcessesByName("ProjectG");
            if (procs.Length != 0)
            {
                pangyahwnd = procs[0].MainWindowHandle;
                GetClientRect(pangyahwnd, out pangyarect);
                return true;
            }
            else
            {
                return false;
            }
        }

        private void AutoPangya()
        {
            presskey(VK_SPACE, 20);
            
            startcap((int)Math.Ceiling(power * 360 / 100) + 3);
            presskey(VK_SPACE, 20);

            if (power >= 80)
            {
                startcap(175);
                SendCommand();
            }

            startcap(panoffset);
            presskey(VK_SPACE, 20);
        }

        private void SendCommand()
        {
            switch (shot)
            {
                case "Toma":
            presskey(VK_UP, 20);
            Thread.Sleep(20);
            presskey(VK_DOWN, 20);
                    break;
                case "Cobra":
            presskey(VK_RIGHT, 20);
            Thread.Sleep(20);
            presskey(VK_UP, 20);
                    break;
                case "Spike":
            presskey(VK_RIGHT, 20);
            Thread.Sleep(20);
            presskey(VK_DOWN, 20);
                    break;
                case "None":
                    break;
            }
            if (spin != 0)
            {
                Thread.Sleep(20);
                presskey(spin, 150);
            }
        }
        
        private void SendKeyEvent(ushort wVk, bool flag)
        {
            INPUT input = new INPUT();
            input.type = 1;
            input.ki.wVk = wVk;
            input.ki.wScan = (ushort)MapVirtualKey(wVk, 0);
            input.ki.time = 0;
            input.ki.dwExtraInfo = GetMessageExtraInfo();
            if (flag)
            {
                if (wVk == VK_SPACE)
                {
                    input.ki.dwFlags = 0x08;
                }
                else
                {
                    input.ki.dwFlags = 0x09;
                }
            }
            else
            {
                if (wVk == VK_SPACE)
                {
                    input.ki.dwFlags = 0x0a;
                }
                else
                {
                    input.ki.dwFlags = 0x0b;
                }
            }
            SendInput(1, ref input, Marshal.SizeOf(typeof(INPUT)));
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            if (RegisterHotKey(Handle, HOTKEY_ID, MOD_CONTROL, (int)Keys.A) == 0)
            {
                MessageBox.Show("Hotkey already registered by another application");
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            UnregisterHotKey(Handle, HOTKEY_ID);
        }

        protected override void WndProc(ref Message m)
        {
            base.WndProc(ref m);
            if (m.Msg == WM_HOTKEY)
            {
                if (((int)m.WParam) == HOTKEY_ID)
                {
                    if (GetPangyaClient())
                    {
                        this.Activate();
                        DrawPanZone();
                    }
                }
            }
        }

        private void startcap(int nDot)
        {
            IntPtr hdc = GetDC(pangyahwnd);
            uint p1 = GetPixel(hdc, 140 + nDot, pangyarect.bottom - 57);
            uint p2;
            do
            {
                p2 = GetPixel(hdc, 140 + nDot, pangyarect.bottom - 57);
            } while (p1 == p2);
            ReleaseDC(pangyahwnd, hdc);
        }

        private void presskey(ushort wVk, int time)
        {
            SendKeyEvent(wVk, true);
            Thread.Sleep(time);
            SendKeyEvent(wVk, false);
        }

        private void DrawPanZone()
        {
            Bitmap bm = new Bitmap(23, 23);
            Graphics g = Graphics.FromImage(bm);
            RECT rect = new RECT();
            GetWindowRect(pangyahwnd, out rect);
            int bdr = (rect.right - rect.left - pangyarect.right) / 2;
            g.CopyFromScreen(new Point(rect.left + bdr + 132 + panoffset, rect.bottom - bdr - 70), new Point(0, 0), bm.Size);
            g.Dispose();
            pictureBox1.Image = bm;
        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.DrawLine(Pens.Red, 12, 0, 12, 23);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if (GetPangyaClient())
            {
                panoffset -= 1;
                DrawPanZone();
            }
        }

        private void button8_Click(object sender, EventArgs e)
        {
            if (GetPangyaClient())
            {
                panoffset += 1;
                DrawPanZone();
            }
        }
    }
}
